$(function() {

	// PHP Values can replace javascript
	phpvars = $.extend({
		'info_timer'		: 15,                               // How often should script check for new artist/title in seconds
		'ajaxtimeout'		: 10000, 							// Timeout of Ajax query
		'artist_maxlen'		: 20,                               // Max length of Artist on the player
		'title_maxlen'		: 30,                               // Max length of Title on the player
		'showTime'			: true,								// Show/Hide playing track timer (current playtime)
		'moreinfo_url'		: 'http://www.last.fm/music/',      // URL where more info button should redirect, (http://site.com/?q=artist (artist is auto added))
		'showtimeout'		: 0,								// 0 = disabled, number = miliseconds before interface hides; note: this is disabled on touch screen devices by default
		}, phpvars);


	// Set some variables for later use
	var trackTimer = 0, NiceREP, ui_timeout, ui_display = true;

	// Remove Loading on document ready
	$(document).ready(function() {

		$('#loading').fadeOut(400);

		// Get info
		window.setInterval("radioInfo()", (phpvars['info_timer'] * 1000));
		radioInfo();

		// Capture settings events
		$('#header .settings').on('click', function() {

			if ($(this).hasClass('open')) {

				$('.content.player').stop(true,true).fadeIn();
				$('.content.settings').hide();
				$(this).removeClass('open').html('<i class="icon-settings"></i>');

			} else {

				$('.content.player').hide();
				$('.content.settings').stop(true,true).fadeIn();
				$(this).addClass('open').html('<i style="color: red;" class="icon-remove"></i>');

			}
		});

		// Capture FB Like toggle
		$('#header .fblike').on('click', function() { $('#header .fbcontent').fadeToggle('fast'); });

		// Capture changes on settings form
		$('.content.settings input, .content.settings select').change(function() {

			var form = $(this).parents('form');
			if ($(this).attr('name') == 'quality' || $(this).attr('name') == 'useflash') {
				var updatePlayer = true; } else { var updatePlayer = false;}

			$.post('index.php?q=settings', $(form).serialize(), function(response) {

				var $ret = $.parseJSON(response);

				if (updatePlayer == true) {
					DeployPlayer($ret);
				}

				if ($ret.colorscheme == 'default') {

					$('#colorscheme').removeAttr('href');

				} else {

					$('#colorscheme').attr('href', $ret.colorscheme);

				}

			});
		});
	});

	DeployPlayer(phpvars);
	MouseMoveFunction();
});

// Functions
function DeployPlayer(user) {

	var solution, supplied, autoplay, supplied = '';

	// Check for solutions from stream urls
	var suparr = new Array();
	$.each(user.streamurl, function(key, value) { suparr.push(key); });
	supplied = suparr.join(', ');

	// Set solutions using user setting for flash
	if (user.useflash == 'true') {
		solution = 'flash, html';
	} else {
		solution = 'html, flash';
	}

	// Auto play check
	if (user.autoplay == 'true') {
		autoplay = 'play';
	}

	var settings = {
		'streams': user.streamurl,
		'supplied': supplied,
		'solution': solution,
		'autoplay': autoplay
	};

	var cVolume = getcookie('pro.radio-player_volume');
	cVolume = ((cVolume != null) ? cVolume : '0.5')

	if (settings.streams == null || settings.supplied == null || settings.solution == null) {
		alert('ERROR: There has been issue with player configuration !');
		return false;
	}

	var stream = settings.streams;

	ready = false;
	// If we have active radio clear media to set new Quality
	$("#ProPlayer").jPlayer("destroy");

	var WebPlayer = $("#ProPlayer"),
	options = {

		swfPath: "assets/flash/jquery.jplayer.swf",
		solution: settings.solution,
		supplied: settings.supplied,
		wmode: "window",
		errorAlerts: false,
		cssSelectorAncestor: "",
		volume: cVolume,
		preload: 'none',
		cssSelector: {
			play: ".play",
			pause: ".stop",
			mute: ".mute",
			volumeMax: ".max-volume",
			volumeBar: ".volume-slider .progress",
			volumeBarValue: ".volume-slider .progress .bar",
			noSolution: ".nosupport"
		},

		ready: function (event) {

			if(event.jPlayer.status.noVolume) {
				// Add a class and then CSS rules deal with it.
				$(".player-volume").hide();
			}

			ready = true;
			$(this).jPlayer("setMedia", stream).jPlayer(settings.autoplay);

		},

		pause: function() {
			$(this).jPlayer("clearMedia");
			status_txt('player stopped', true);
		},

		error: function(event) {
			if(ready && event.jPlayer.error.type === $.jPlayer.error.URL_NOT_SET) {
				// Setup the media stream again and play it.
				$(this).jPlayer("setMedia", stream).jPlayer('play');
			}
		},

		volumechange: function(event) {

			// Change main volume icons
			if (event.jPlayer.options.muted || event.jPlayer.options.volume < 0.01) {

				$('.player-volume .volume-icon').removeClass('icon-volume icon-mute').addClass('icon-mute');

			} else {

				$('.player-volume .volume-icon').removeClass('icon-volume icon-mute').addClass('icon-volume');

			}

			if (event.jPlayer.options.muted) { status_txt('player muted'); } else { status_txt('Volume: ' + Math.floor(event.jPlayer.options.volume * 100) + '%'); }
			setcookie('pro.radio-player_volume', event.jPlayer.options.volume, 386);

		}
	};

	// Instance jPlayer
	WebPlayer.jPlayer(options);

	// Create the volume slider control
	$('.player-volume').mousedown(function() {

		parent = $('.volume-slider .progress');

		$('.volume-slider .progress').mousemove(function(e){

			$('.volume-slider .progress .bar').css({
				'width': e.pageX - $(parent).offset().left +1
			});

			var total = $('.volume-slider .progress').width();
			WebPlayer.jPlayer("option", "muted", false);
			WebPlayer.jPlayer("option", "volume", (e.pageX - $(parent).offset().left +1) / total);

			return false;
		})

		return false;

	}).mouseup(function() {

		$('.volume-slider .progress').unbind('mousemove');

	});

	// Remove loading message when player starts playing
	$("#ProPlayer").unbind($.jPlayer.event.play); $("#ProPlayer").unbind($.jPlayer.event.playing);
	$("#ProPlayer").bind($.jPlayer.event.play, function(event) { status_txt('Loading, please wait...', true); });
	$("#ProPlayer").bind($.jPlayer.event.playing, function(event) { status_txt('now playing', true); });


}

// Get stats info (Time out 5s)
function radioInfo() {

	$.ajax({

		url: 'index.php?q=info',
		cache: false,
		dataType: 'json',
		timeout: phpvars.ajaxtimeout,

		success: function(data) {

			if (data == null) { return false; }

			$('.stream-info .artist').html('<a data-title="' + data.artist + '" href="#">' + shorten(data.artist, phpvars.artist_maxlen) + '</a>');
			$('.stream-info .title').html('<a data-title="' + data.title + '" href="#">' + shorten(cleartrack(data.title), phpvars.title_maxlen) + '</a>');


			if (data['artist-image'] != null) {
				$('.artist-image img').attr('src', data['artist-image']);
				$('.artist-image a').attr('href', phpvars.moreinfo_url + data.artist);
			}

			// Set stuff for tracking the track timer
			clearInterval(window.trackTimer);
			window.trackTime 	 = data.time.current;

			if (data.time.current != 'false' && phpvars.showTime != false) {

				// Execute timer function
				tracktime();

				// now interval it every second to count up time.
				window.trackTimer = setInterval("tracktime()", 1000);

			} else {

				// No time could be parsed, clear track time
				$('.stream-info .playtime').empty();

			}

	}});

}

// Function to base track timer on Javascript instead of Server
function tracktime() {

	// Display loading if track time is less then 1 sec and more then total track duration
	if (window.trackTime < 1) {

		// Display loading only once and reset track progress bar to 0
		if (!$('.stream-info .playtime i').length) {

			$('.stream-info .playtime').html('<i><div class="spinner spinner-small"></div> Loading...</i>');
			// $('#progress .trackbar').width('0px');
			setTimeout(radioInfo, 5000);
		}

	} else {

		// Display timer if all is ok
		var hour = ((Math.floor((window.trackTime / 3600) % 60) > 9) ? Math.floor((window.trackTime / 3600) % 60) : '0' + Math.floor((window.trackTime / 3600) % 60));
		var min  = ((Math.floor((window.trackTime / 60) % 60) > 9) ? Math.floor((window.trackTime / 60) % 60) : '0' + Math.floor((window.trackTime / 60) % 60));
		var sec  = (((window.trackTime % 60) > 9) ? Math.floor(window.trackTime % 60) : '0' + Math.floor(window.trackTime % 60));
		var timer;

		// Display only active timer (1h 2min 3sec)
		if (hour >= 1) { timer = hour + ':' + min + ':' + sec + ''; }
		else { timer = min + ':' + sec + ''; }

		// Write playtime on player
		$('.stream-info .playtime').html(timer);
	}

	// Add 1second to timer
	window.trackTime++;

}

// Simple function to use some jquery magic
function status_txt(newText, perment) {

	var status = $('.stream-info .player-status');

	// Set previous text into data-name attribute
	if (status.attr('data-text') == undefined && perment != true) {
		status.attr('data-text', status.text());
	}

	// Get old text from attribute
	var oldText = status.attr('data-text');

	// Don't set new timeout of there is one already!
	if (window.NiceREP != null) {
		window.clearTimeout(NiceREP);
	}

	// Set new text into the element
	status.html(newText);

	// Create Timer into window.object
	if (perment == null) {
		NiceREP = setTimeout(function() { status.hide().html(oldText).fadeIn('slow').removeAttr('data-text'); }, 2200);
	}

	return true;
}

// Mouse Move Function (binds to body and when mouse is not moved for X time it hides UI)
function MouseMoveFunction() {

	// Disabled
	if (phpvars['showtimeout'] == '0' || isTouchDevice()) { return false; }

	$('body').mousemove(function() {

		if (window.ui_display == false) {
			$('#header').css({ 'margin-top': '0' });
			$('.content.player .player').css({ 'overflow': 'visible', 'width': '64px' });
			window.ui_display = true;
		}

		clearTimeout(window.ui_timeout);
		window.ui_timeout = setTimeout(function() {

			$('#header').css({ 'margin-top': '-50px' });
			$('.content.player .player').css({ 'width': '0', 'overflow': 'hidden' });
			window.ui_display = false;
			}, phpvars['showtimeout']);

	});



}

// Page specific functions
function cleartrack(name) {
	return name.replace(/ \(.*/, '');
}

// Function that shortens text by value set.
function shorten($text, $length) {
	var length = $length || 10;
	if ($text.length > length) {
		$text = $text.substring(0, length)+'&hellip;';
	}
	return $text;
}

// Open New Window Help Function
function newWindow(url, width, height, win) {
	window.open(url,win,'width='+width+',height='+height+',left=10,top=10,resizable=yes,scrollbars=no,toolbar=no,menubar=no,location=no,directories=no,status=yes,toolbar=no');
}

// Simple function to write cookie
function setcookie(name, value, expires, path, domain, secure) {

	var today = new Date();
	today.setTime(today.getTime());

	if (expires) {
		expires = expires * 1000 * 60 * 60 * 24;
	}

	var expires_date = new Date(today.getTime() + (expires));

	document.cookie = name+'=' + escape(value) +
	((expires) ? ';expires='+ expires_date.toGMTString() : '') + //expires.toGMTString()
	((path) ? ';path=' + path : '') +
	((domain) ? ';domain=' + domain : '') +
	((secure) ? ';secure' : '');

}

// Read cookievalue
function getcookie( name ) {

	var start = document.cookie.indexOf(name + "=");
	var len = start + name.length + 1;

	if ((!start) && (name != document.cookie.substring(0, name.length))) {
		return null;
	}

	if (start == -1) return null;

	var end = document.cookie.indexOf(';', len);

	if (end == -1) end = document.cookie.length;
	return unescape( document.cookie.substring(len, end));

}

// Delete cookie
function delcookie( name, path, domain ) {
	if (getcookie( name )) document.cookie = name + '=' +
		((path) ? ';path=' + path : '') +
		((domain) ? ';domain=' + domain : '') +
		';expires=Thu, 01-Jan-1970 00:00:01 GMT';

}

function isTouchDevice(){
	return typeof window.ontouchstart !== 'undefined';
}